package com.jdbernard.timeanalyzer.categorizationplans

import com.jdbernard.timeanalyzer.categories.Category
import com.jdbernard.timeanalyzer.categories.DescriptionBasedCategory
import com.jdbernard.timeanalyzer.events.Event

public class DescriptionBasedCategorizationPlan implements CategorizationPlan {

    public boolean deservesNewCategory(Event event, List<Event> existingEvents) {
        def desc = event.description.replaceAll(/\p{Punct}/, '').toLowerCase()
        return existingEvents.any {
            it.description.replaceAll(/\p{Punct}/, '').toLowerCase() == desc }
    }

    public Category newCategory(Event event,
    List<Event> existingEvents) {
        return new DescriptionBasedCategory(event.description)
    }

    public List<Event> findEventsToRecategorize(Event event,
    List<Event> existingEvents) {
        def desc = event.description.replaceAll(/\p{Punct}/, '').toLowerCase()
        return existingEvents.findAll {
            it.description.replaceAll(/\p{Punct}/, '').toLowerCase() == desc }
    }

}
